function [Se,SSe] = minlp(X,A,alpha,W,op)


Wd2 = W/2;

T=size(X,2); 
L=size(A,3);
NbS = size(A,2);
fmat=exp(-2*1i*pi/W*(0:L-1).'*(0:Wd2));
Af=reshape(reshape(A,2*NbS,L)*fmat,2,NbS,Wd2+1);



XX(:,:,1)=op.analysis(X(1,:));
XX(:,:,2)=op.analysis(X(2,:));

[F,N] = size(XX(:,:,1));

SSe = zeros(F,N,NbS);


for k=1:N
  for f=1:F
    xx = XX(f,k,:);
    AAf = Af(:,:,f);
    SSe(f,k,:)=reshape(sparsopt(xx(:),AAf,alpha),1,1,NbS);
  end
end

Se=zeros(NbS,T);

for j=1:NbS
     Se(j,:)=op.synthesis(SSe(:,:,j));
end

return;