function Se=sep_freq(X,A,L_win,op)

% séparation avec projection dans le domaine fréquentiel



T=size(X,2); 
L=size(A,3);
NbS = size(A,2);
fmat=exp(-2*1i*pi/(L_win)*(0:L-1).'*(0:(L_win/2)));
Af=reshape(reshape(A,2*NbS,L)*fmat,2,NbS,L_win/2+1);

XX(:,:,1)=op.analysis(X(1,:));
XX(:,:,2)=op.analysis(X(2,:));

[F,N] = size(XX(:,:,1));

YY=zeros(F,N,NbS);

for f=1:F
    YY(f,:,:)=reshape(XX(f,:,:),N,2)*(conj(Af(:,:,f))./(ones(2,1)*sum(abs(Af(:,:,f)).^2)));
end
YY=reshape(YY,F*N,NbS);
W=sqrt(.5*reshape(sum(abs(Af).^2),NbS,F)).';
W=reshape(repmat(reshape(W,F,1,NbS),[1 N 1]),F*N,NbS);
[~,ind]=max(abs(YY).*W,[],2);
SSe=zeros((L_win/2+1)*N,NbS);
for j=1:NbS
     SSe(ind==j,j)=YY(ind==j,j);
end
SSe=reshape(SSe,F,N,NbS);
Se=zeros(NbS,T);
for j=1:NbS
     Se(j,:)=op.synthesis(SSe(:,:,j));
end

return;
