function lambda = power_iteration(A,T,op,options)


if ~isfield(options, 'maxitl')
    options.maxitl = 1000; 
end

[~,N,K] = size(A);
 At = retourne_mat(A);
  
tr = op.analysis(ones(1,T));
[Mtr,Ntr] = size(tr);
dcc = ones(Mtr,Ntr,N);
Sg = ones(N,T);
AtAdcc = zeros(Mtr,Ntr,N);

lambda = 1;

for it=1:options.maxitl
    lambdaold = lambda;
    for n=1:N
        s = op.synthesis(dcc(:,:,n));
        Sg(n,:) = s(:)';
    end
    AS =  creation_mel_conv(A,Sg);
    AtAS = creation_mel_conv(At,AS);
    AtAS = AtAS(:,K:T+K-1);
    for n=1:N
        AtAdcc(:,:,n) = op.analysis(AtAS(n,:));
    end

    lambda = max(max(max(abs(AtAdcc))));
    dcc = AtAdcc/lambda;
    if abs(lambda-lambdaold)/lambda < 1e-4
        break;
    end
end
  
