function dccShrink = prox(dccS,lambda,penalty)   
   
[Mtr,Ntr,N] = size(dccS);
argdccS = zeros(Mtr,Ntr,N);   
argdccS(dccS~=0) = dccS(dccS~=0)./abs(dccS(dccS~=0)) ;

[Mtr,Ntr,N] = size(dccS);

if (lambda==0) || (sum(dccS(:))==0)
    dccShrink=dccS;
    return;
end


switch penalty
  
 case 'l12'
  %%% Calcul de la constante "L"
  dccSort = sort(abs(dccS),3,'descend');
  matind = zeros(Mtr,Ntr,N);
  for n=1:N
    matind(:,:,n) = n*ones(Mtr,Ntr);
  end
  
  cumnorm1 = cumsum(dccSort,3);
  
  
  diff = dccSort-lambda.*(cumnorm1-matind.*dccSort);
  [ind] = find(diff<=0);
  matind(ind) = 0;
  
  %%% Calcul de ||| dccS |||
  indLok = max(matind,[],3);
  idm = reshape(1:Mtr*Ntr,Mtr,Ntr);
  ind = (indLok-1).*(Mtr*Ntr) + idm;
  
  ind = ind(:);
  norm1 = reshape(cumnorm1(ind),Mtr,Ntr);
  
  norm1 = repmat(norm1,[1,1,N]);
  LL = repmat(indLok,[1,1,N]);  
  seuil = (lambda.*norm1)./(1+lambda.*LL);
 
 case 'l1'
  seuil = lambda;

end

dccShrink = argdccS.*SoftThresh(abs(dccS),seuil);
