function [SDR,SIR,SAR] = bsseval(se,S,L)

[N,T] = size(S);
S2 = zeros(1,T,N);
S2(1,:,:) = S';
SDR = zeros(1,N);
SIR = zeros(1,N);
SAR = zeros(1,N);

for i=1:N
  [s_target,e_interf,e_artif]=bss_decomp_filt2(se(i,:),S2,i,L);
  [SDR(i),SIR(i),SAR(i)]=bss_crit(s_target,e_interf,e_artif);
end